/*
 *	hdvd_tray.h
 *	Copyright (c) 2015 Sony Corporation. All rights reserved.
 */

#ifndef	HDVD_TRAY_INCLUDED
#define	HDVD_TRAY_INCLUDED

#ifdef  __cplusplus
extern "C" {
#endif	// __cplusplus

#include <linux/types.h>
#include <linux/ioctl.h>

#define	PWM_CYCLE	10	// 10 jiffies (100msec)
#define	TRAY_OPEN_TIMEOUT	745	// stop motor when keeps tray driving 7 secs
#define	TRAY_CLOSE_TIMEOUT	600	// stop motor when keeps tray driving 7 secs

typedef	enum {E_NOP, E_OPEN, E_CLOSE, E_BRAKE, E_TIMEOUT} E_TRAY_STATE;
typedef	enum {E_UNKNOWNPOS, E_OPENED, E_CLOSED, E_HALFOPENED, E_END} E_TRAY_POSITION;

#define HDVD_TRAY_IOCTL_MAGIC	204
#define HDVD_TRAY_IOC_GETPOS	_IOC(_IOC_READ, HDVD_TRAY_IOCTL_MAGIC, 0, sizeof(E_TRAY_POSITION *) )
#define HDVD_TRAY_IOC_ACT	_IOC(_IOC_WRITE, HDVD_TRAY_IOCTL_MAGIC, 1, sizeof(E_TRAY_STATE) )
#define HDVD_TRAY_IOC_CANSEL	_IOC(_IOC_WRITE, HDVD_TRAY_IOCTL_MAGIC, 2, 0 )
#ifdef  __cplusplus
}
#endif	// __cplusplus

#endif	// HDVD_TRAY_INCLUDED
